/****************************************************************
Widget Streams-T - Windows Mobile 6.5 widget for Marketplace

Contact: widget@todaypda.com

Copyright (c) 2009 TodayPDA.com.  All rights reserved.
****************************************************************/

/**************************************Loading**************************************/

function load_url(url, target) {
  refreshURLS();
  if (window.XMLHttpRequest) {
    req = new XMLHttpRequest();
  } else if (window.ActiveXObject) {
    req = new ActiveXObject("Microsoft.XMLHTTP");
  }
  if (req != undefined) {
    req.onreadystatechange = function() {load_url_done(url, target);};
    req.open("GET", url, true);
    req.send("");
  }
}

function load_url_noerror(url, target) {
  if (window.XMLHttpRequest) {
    req = new XMLHttpRequest();
  } else if (window.ActiveXObject) {
    req = new ActiveXObject("Microsoft.XMLHTTP");
  }
  if (req != undefined) {
    req.onreadystatechange = function() {
      if (req.readyState == 4) {
        if (req.status == 200) {
          document.getElementById(target).innerHTML = req.responseText;
        } else {
          document.getElementById(target).innerHTML="";
        }
      }
    };
    req.open("GET", url, true);
    req.send("");
  }
}

function load_url_done(url, target) {
  if (req.readyState == 4) {
    if (req.status == 200) {
      document.getElementById(target).innerHTML = req.responseText;
    } else {
      document.getElementById(target).innerHTML=" Error:\n"+ req.status + "\n" +req.statusText + LANG_TEXT['error_internet'];
    }
  }
}

function load(name, div) {
  document.getElementById(div).innerHTML = LANG_URL['loading'];
  refreshpage = name;
  SetLeftSoftKeyToRefresh();
	load_url(name,div);
	return false;
}

function load_refresh(name, div) {
  document.getElementById(div).innerHTML = LANG_URL['loading'];
  load_url(name,div);
	return false;
}


/**************************************Favorites**************************************/

function setFavorites(data, favorites_added, storage_favorites_full) {
  if (getSetting('streamFavorites') == null) {
    saveSetting('streamFavorites', data + '---');
  } else {
    var temp_count_favs = getSetting('streamFavorites');
    if(temp_count_favs.length > 300) {
      alert(storage_favorites_full);
    } else {
      saveSetting('streamFavorites', data + '---' + getSetting('streamFavorites'));
      alert(favorites_added);
    }
  }
}

function removeFavorites(data, favorites_removed) {
  var myStringOutput = '';
  var myString = getSetting('streamFavorites');
  var mySplitResult = myString.split("---");
  for(i = 0; i < (mySplitResult.length - 1); i++){
    var myStringTemp = mySplitResult[i];
    if (myStringTemp != data) {
      myStringOutput = myStringOutput + myStringTemp + '---';
    }
  }
  saveSetting('streamFavorites', myStringOutput);
  alert(favorites_removed);
  document.getElementById('content').innerHTML = LANG_URL['loading'];
  load_url(LANG_URL['favorites'] + 'favorites_id=' + getSetting('streamFavorites') + '&','content');
}

/**************************************Menu**************************************/

function direct_createMenuItem(d,c,b){
  var a=null;
  if(window.widget&&window.widget.menu){
    var a=window.widget.menu.createMenuItem(d);
    if(a){
      a.text=c;a.onSelect=b
    }
  }
  return a
}

function direct_getMenuItemById(b){
  var a=null;
  if(window.widget&&window.widget.menu) {
    a=window.widget.menu.getMenuItemById(b);
  }
  return a
}

function direct_appendMenuItem(a){
  if(a&&window.widget&&window.widget.menu) {
    window.widget.menu.append(a);
  }
}

function direct_removeMenuItem(a){
  if(a&&window.widget&&window.widget.menu) {
    window.widget.menu.remove(a);
  }
}

function direct_setSoftKey(a,b){
  if(a&&window.widget&&window.widget.menu) {
    window.widget.menu.setSoftKey(a,b);
  }
}

function direct_setLeftSoftKey(a){
  if(a&&window.widget&&window.widget.menu) {
    window.widget.menu.setSoftKey(a,widget.menu.leftSoftKeyIndex);
  }
}

function direct_setRightSoftKey(a){
  if(a&&window.widget&&window.widget.menu) {
    window.widget.menu.setSoftKey(a,widget.menu.rightSoftKeyIndex);
  }
}

function direct_toggleMenuItem(b,c){
  var a=direct_getMenuItemById(b);
  if(a) {
    a.enabled=c;
  }
}

/**************************************Settings**************************************/

function saveSettingOnline(name, data, alert_text){
  saveSetting(name, data);
  alert(alert_text);
  refreshURLS();
  document.getElementById('content').innerHTML = LANG_URL['loading'];
  load_url(LANG_URL['settings'], 'content');
}

function saveSetting(name, data) {
  widget.setPreferenceForKey(data, name);
}

function getSetting(name) {
  return widget.preferenceForKey(name);
}

/**************************************Simple functions**************************************/

function encodeURLdata(data) {
	var temp = data.replace(/\+/g, "||||");
  temp = escape(temp);
  return temp;
}

function randomString() {
	var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz";
	var string_length = 20;
	var randomstring = '';
	for (var i=0; i<string_length; i++) {
		var rnum = Math.floor(Math.random() * chars.length);
		randomstring += chars.substring(rnum,rnum+1);
	}
	return randomstring;
}

function getDeviceDPI() {
  var a=document.documentElement.clientWidth>=480?'1':'0';
  return a;
}

/**************************************Startup**************************************/

function startSetup() {
  document.getElementById('start_television').innerHTML = LANG_TEXT['television'];
  document.getElementById('start_webcam').innerHTML = LANG_TEXT['webcam'];
  document.getElementById('start_radio').innerHTML = LANG_TEXT['radio'];
  startPageShow();
}

function startPageShow() {
  document.getElementById('content').innerHTML = '<br /><br /><center><b>' + widget.name + ' v' + widget.version + '</b></center><br /><div id="content_news" class="content_news"></div>';
  load_url_noerror(LANG_URL['news'], 'content_news');
  disableMenuItem(REFRESH_MENU_ITEM_ID);
}